﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel view;
        public MainWindow()
        {
            InitializeComponent();
            view = new ViewModel();
            series.ItemsSource = view.DataPoints;
        }

        private void SfChart_MouseDown(object sender, MouseButtonEventArgs e)
        {
            FrameworkElement element = e.OriginalSource as FrameworkElement;
            if (element != null && element.Tag is ChartSegment)
            {
                ChartSegment segment = element.Tag as ChartSegment;
                Entity data = segment.Item as Entity;
                var value = data.dataX;
                //Method(value);
            }
            else
            {
                int index = -1;
                if (element.DataContext is ChartAdornmentContainer)
                    index = (int)(element.DataContext as ChartAdornmentContainer).Tag;
                else
                {
                    while (!(element is ChartAdornmentContainer) && element != null)
                    {
                        element = VisualTreeHelper.GetParent(element) as FrameworkElement;
                        //Get the Adornment index when set the Content control for LabelTemplate. 
                        if (element is ContentControl && (element as ContentControl).Tag is int)
                        {
                            index = (int)(element as ContentControl).Tag;
                        }
                        //Get the Adornment index when set the SymbolTemplate for Adornments. 
                        else if (element is ChartAdornmentContainer)
                            index = (int)(element as ChartAdornmentContainer).Tag;
                    }
                }

                if (index != -1 && index <= series.LineSegments.Count)
                {
                    var value = view.DataPoints[index].dataX;
                }
            }
        }

    }

    class ViewModel
    {
        public ViewModel()
        {
            this.DataPoints = new ObservableCollection<Entity>()
            {
                new Entity() { dataX = "Milk", dataY = 12 },
                new Entity() { dataX = "Cookies", dataY = 45 },
                new Entity() { dataX = "Chestnuts", dataY = 8 },
                new Entity() { dataX = "Chocolate", dataY = 5 },
                new Entity() { dataX = "Beverages", dataY = 37 },
                new Entity() { dataX = "Foods", dataY = 25 },
                new Entity() { dataX = "Snacks", dataY = 18 }
            };
        }
        public ObservableCollection<Entity> DataPoints { get; set; }
    }

    class Entity
    {
        public string dataX { get; set; }

        public double dataY { get; set; }

    }

    //In order to get the line segments, inherit the series from line series. 
    public class CustomLineSeries:LineSeries
    {
        public CustomLineSeries()
        {
            //To get the internal line segments collection.
            LineSegments = base.Segments;
        }

        public ObservableCollection<ChartSegment> LineSegments { get; set; }
    }
}
